package ch.unibe.piccola;

/**
 * Entry point for standalone execution of the Piccola runtime environment.
 * Set this class as main class in the Jar's manifest.
 *
 * @author   Stefan Kneubuehl
 * @version  3.4c (Oct 01, 2002)
**/
public class Main
{

    // ------------------------------------------------------------------------
    // main method
    // ------------------------------------------------------------------------

    /**
     * Creates a new host and executes the script given as first command line
     * argument or, if missing, the default script defined in the
     * <code>piccola.script</code> system property.
    **/
    public static final void main(String[] args)
    {
        Host host = new Host();
        System.out.println("Initializing host ...");
        host.initialize();
        if (args.length > 0 && args[0].equals("debug")) {
            host.setObserverFactory(new LogDebuggerFactory());
        }
        String script = args.length > 0 ?
            args[args.length - 1] :
            host.getProperty("piccola.script");
        System.out.println("Executing script '" + script + "' ...");
        host.executeScript(script);
    }

}