package ch.unibe.piccola.bridge;

import java.awt.event.AdjustmentEvent;
import java.awt.event.AdjustmentListener;
import ch.unibe.piccola.vm.Form;
import ch.unibe.piccola.vm.Service;

/**
 * Implements a generic <code>AdjustmentListener</code>.
 *
 * @author   Stefan Kneubuehl
 * @version  4.0 (Jun 09, 2003)
**/
public class GenericAdjustmentListener extends GenericListener
    implements AdjustmentListener
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    public GenericAdjustmentListener(Form handler)
    {
        m_adjustmentValueChanged = extractService(handler, "adjustmentValueChanged");
    }

    public void adjustmentValueChanged(AdjustmentEvent event)
    {
        m_adjustmentValueChanged.callback(this, event);
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private final Service m_adjustmentValueChanged;

}
