package ch.unibe.piccola.bridge;

import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import ch.unibe.piccola.vm.Form;
import ch.unibe.piccola.vm.Service;

/**
 * Implements a generic <code>FocusListener</code>.
 *
 * @author   Stefan Kneubuehl
 * @version  4.0 (Jun 09, 2003)
**/
public class GenericFocusListener extends GenericListener
    implements FocusListener
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    public GenericFocusListener(Form handler)
    {
        m_focusGained = extractService(handler, "focusGained");
        m_focusLost = extractService(handler, "focusLost");
    }

    public void focusGained(FocusEvent event)
    {
        m_focusGained.callback(this, event);
    }


    public void focusLost(FocusEvent event)
    {
        m_focusLost.callback(this, event);
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private final Service m_focusGained;

    private final Service m_focusLost;

}
