package ch.unibe.piccola.bridge;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import ch.unibe.piccola.vm.Form;
import ch.unibe.piccola.vm.Service;

/**
 * Implements a generic <code>PropertyChangeListener</code>.
 *
 * @author   Stefan Kneubuehl
 * @version  4.0 (Jun 09, 2003)
**/
public class GenericPropertyChangeListener extends GenericListener
    implements PropertyChangeListener
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    public GenericPropertyChangeListener(Form handler)
    {
        m_propertyChange = extractService(handler, "propertyChange");
    }

    public void propertyChange(PropertyChangeEvent event)
    {
        m_propertyChange.callback(this, event);
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private final Service m_propertyChange;

}
