package ch.unibe.piccola.bridge;

import javax.swing.event.TreeExpansionEvent;
import javax.swing.event.TreeWillExpandListener;
import ch.unibe.piccola.vm.Form;
import ch.unibe.piccola.vm.Service;

/**
 * Implements a generic <code>TreeWillExpandListener</code>.
 *
 * @author   Stefan Kneubuehl
 * @version  4.0 (Jun 09, 2003)
**/
public class GenericTreeWillExpandListener extends GenericListener
    implements TreeWillExpandListener
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    public GenericTreeWillExpandListener(Form handler)
    {
        m_treeWillCollapse = extractService(handler, "treeWillCollapse");
        m_treeWillExpand = extractService(handler, "treeWillExpand");
    }

    public void treeWillCollapse(TreeExpansionEvent event)
    {
        m_treeWillCollapse.callback(this, event);
    }

    public void treeWillExpand(TreeExpansionEvent event)
    {
        m_treeWillExpand.callback(this, event);
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private final Service m_treeWillCollapse;

    private final Service m_treeWillExpand;

}
