package ch.unibe.piccola.bytecode;

import ch.unibe.piccola.PiccolaException;

import java.util.ArrayList;
import java.lang.reflect.Method;

import org.apache.bcel.Constants;
//import org.apache.bcel.util.Class2HTML;
import org.apache.bcel.generic.ClassGen;

/**
 * @author  $Id: AbstractFactory.java,v 3.5 2003/01/10 13:46:23 kneubuhl Exp $
**/

abstract public class AbstractFactory implements FactoryConstants, Constants {

	protected ConstructorFactory m_ConstructorFactory;
	
	protected MethodFactory m_MethodFactory;

	protected FieldFactory m_FieldFactory;

	protected ServiceHandlerFactory m_ServiceHandlerFactory;

	protected ClassGen createClass(String className, String superClassName, 
									ArrayList interfaceNameList, int accessModifiers,
									ArrayList fieldDeclarationList,
									ArrayList methodDeclarationList) {

		ClassGen cg = createClassFile(className, superClassName, accessModifiers, interfaceNameList);
		m_ConstructorFactory = new ConstructorFactory(cg);
		m_FieldFactory = new FieldFactory(cg);
		m_MethodFactory = new MethodFactory(cg);
		m_ServiceHandlerFactory = new ServiceHandlerFactory(cg);
	
		cg = m_ConstructorFactory.addConstructor(className, superClassName);
		
		cg = m_FieldFactory.addField(generateFieldName("delegate"));
		cg = m_ServiceHandlerFactory.addServiceHandlerMethod(className);

		// Create additional member variables
		if (null != fieldDeclarationList)  {
			for (int i=0; i<fieldDeclarationList.size(); i++) {
				cg = m_FieldFactory.addField((FieldDeclaration) fieldDeclarationList.get(i));
			}
		}
		
		for (int i=0; i<methodDeclarationList.size(); i++) {
			MethodDeclaration method = (MethodDeclaration) methodDeclarationList.get(i);
			cg = m_MethodFactory.addMethod(className, method);
    	}
	    /* 	
		try {
            System.err.println( "Class2HTML");
			Class2HTML dummy = new Class2HTML(cg.getJavaClass(),"/tmp/piccola/bytecode/");
		} catch(java.io.IOException ie) {System.err.println(ie.toString());}
        */
		return cg;
	}
	
	protected ClassGen createClassFile(String className, String superClassName, 
										int accessModifiers, ArrayList interfaceNameList) {
		String[] interfaceNameArray = null;
		if (null !=interfaceNameList) {
			interfaceNameArray = new String[interfaceNameList.size()];
			for (int i=0; i<interfaceNameList.size(); i++) {
				interfaceNameArray[i] = (String) interfaceNameList.get(i);
			}
		}
		
		ClassGen cg = new ClassGen(className, superClassName,
								   "<schlpbch>", accessModifiers | ACC_SUPER,
								   interfaceNameArray);
		return cg;
    }

	protected ArrayList getMethodsOfClassOrInterface(String className) {
    	Class aClass = TypeConverter.getClass(className);
    	Method[] methods = null;
    	try {
      		methods = aClass.getMethods();
    	}
    	catch(SecurityException e) {
			throw new PiccolaException("Bridge: SecurityException");
		}
		// Convert to an ArrayList
		ArrayList methodArrayList = new ArrayList();
		for (int i=0; i<methods.length; i++) {
			methodArrayList.add((Method) methods[i]);
		}
    	return methodArrayList;
  	}
	
	private String generateFieldName(String name) {
		return "m_" + name;
	}

}
