package ch.unibe.piccola.bytecode;

import java.util.ArrayList;
import java.lang.reflect.Field;

public class FieldDeclaration extends AbstractDeclaration {
	final private Class m_type;

	public FieldDeclaration(String name, int modifiers, Class type) {
		m_name = name;
		m_modifiers = modifiers;
		m_type = type;
	}

	public FieldDeclaration(Field field) {
		m_name = field.getName();
		m_modifiers = field.getModifiers();
		m_type = field.getType();
	}

	public Class getType() {
		return m_type;
	}

	public String toString() {
		StringBuffer strBuf = new StringBuffer();
		strBuf.append("Name:        ").append(m_name);
		strBuf.append("\nModifiers:   ").append(m_modifiers);
		strBuf.append("\nType: ").append(m_type.getName());
		return strBuf.toString();

	}
}
