package ch.unibe.piccola.bytecode;

import ch.unibe.piccola.code.Arguments;
import ch.unibe.piccola.vm.Form;
import ch.unibe.piccola.vm.Service;

public class ImplMultipleArgumentInterfaceTest
			implements MultipleArgumentInterfaceTest{

	private Service m_voidAIntBoolean;
	private Service m_voidAIntInt;
	private Service m_voidABooleanInt;
	private Service m_voidAIntObject;
	private Service m_voidAObjectInt;
	private Service m_voidAObjectObject;
	private Service m_voidAObjectObjectObject;
	private Service m_voidAObjectObjectObjectObject;

    protected Service extractService(Form handler, String name)
    {
        return handler.project(name).service();
    }

	public ImplMultipleArgumentInterfaceTest(Form delegate) {
		m_voidAIntBoolean = extractService(delegate, "voidAIntBoolean");
		m_voidAIntInt = extractService(delegate, "voidAIntInt");
		m_voidABooleanInt = extractService(delegate, "voidABooleanInt");
		m_voidAIntObject = extractService(delegate, "voidAIntObject");
		m_voidAObjectInt = extractService(delegate, "voidAObjectInt");
		m_voidAObjectObject = extractService(delegate, "voidAObjectObject");
		m_voidAObjectObjectObject = extractService(delegate, "voidAObjectObjectObject");
		m_voidAObjectObjectObjectObject = extractService(delegate, "voidAObjectObjectObjectObject");
	}

	public void voidAIntBoolean(int i, boolean b) {
		Arguments argumentList = new Arguments();
		argumentList.add(this);
		argumentList.add(new Integer(i));
		argumentList.add(new Boolean(b));
		m_voidAIntBoolean.callback(argumentList);
	}

	public void voidAIntInt(int i1, int i2) {
		Arguments argumentList = new Arguments();
		argumentList.add(this);
		argumentList.add(new Integer(i1));
		argumentList.add(new Integer(i2));
		m_voidAIntInt.callback(argumentList);
	}

	public void voidABooleanInt(boolean b, int i) {
		Arguments argumentList = new Arguments();
		argumentList.add(this);
		argumentList.add(new Boolean(b));
		argumentList.add(new Integer(i));
		m_voidABooleanInt.callback(argumentList);
	}

	public void voidAIntObject(int i, Object obj) {
		Arguments argumentList = new Arguments();
		argumentList.add(this);
		argumentList.add(new Integer(i));
		argumentList.add(obj);
		m_voidAIntObject.callback(argumentList);
	}

	public void voidAObjectInt(Object obj, int i) {
		Arguments argumentList = new Arguments();
		argumentList.add(this);
		argumentList.add(obj);
		argumentList.add(new Integer(i));
		m_voidAObjectInt.callback(argumentList);
	}

	public void voidAObjectObject(Object obj1, Object obj2) {
		Arguments argumentList = new Arguments();
		argumentList.add(this);
		argumentList.add(obj1);
		argumentList.add(obj2);
		m_voidAObjectObject.callback(argumentList);
	}

	public void voidAObjectObjectObject(Object obj1, Object obj2, Object obj3) {
		Arguments argumentList = new Arguments();
		argumentList.add(this);
		argumentList.add(obj1);
		argumentList.add(obj2);
		argumentList.add(obj3);
		m_voidAObjectObjectObject.callback(argumentList);
	}

	public void voidAObjectObjectObjectObject(Object obj1, Object obj2, Object obj3, Object obj4) {
		Arguments argumentList = new Arguments();
		argumentList.add(this);
		argumentList.add(obj1);
		argumentList.add(obj2);
		argumentList.add(obj3);
		argumentList.add(obj4);
		m_voidAObjectObjectObjectObject.callback(argumentList);
	}
}


