package ch.unibe.piccola.code;

import ch.unibe.piccola.source.SourceRef;

/**
 * @author   Stefan Kneubuehl
 * @version  3.6c (May 11, 2003)
**/
class OpJavaCall extends OpCode
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    public final boolean equals(Object object)
    {
        if (!super.equals(object)) {
            return false;
        }
        OpJavaCall other = (OpJavaCall) object;
        return m_javaOp.equals(other.m_javaOp) &&
               m_target.equals(other.m_target);
    }

    public final void execute(IVM vm)
    {
        vm.opJavaCall(m_javaOp, m_target);
    }

    public final String toString()
    {
        return "OpJavaCall(" + m_target + "." + m_javaOp + ")";
    }

    // ------------------------------------------------------------------------
    // default
    // ------------------------------------------------------------------------

    OpJavaCall(SourceRef sourceRef, JavaOp javaOp, Object target)
    {
        super(sourceRef);
        m_javaOp = javaOp;
        m_target = target;
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private final JavaOp m_javaOp;

    private final Object m_target;

}

