package ch.unibe.piccola.code;

import ch.unibe.piccola.source.SourceRef;

/**
 * @author   Stefan Kneubuehl
 * @version  3.4c (Aug 08, 2002)
**/
class OpJavaObject extends OpCode
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    public final boolean equals(Object object)
    {
        if (!super.equals(object)) {
            return false;
        }
        return m_object.equals(((OpJavaObject) object).m_object);
    }

    public final void execute(IVM vm)
    {
        vm.opJavaObject(m_object);
    }

    public final String toString()
    {
        return "OpJavaObject(" + m_object + ")";
    }

    // ------------------------------------------------------------------------
    // default
    // ------------------------------------------------------------------------

    OpJavaObject(SourceRef sourceRef, Object object)
    {
        super(sourceRef);
        m_object = object;
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private final Object m_object;

}