package ch.unibe.piccola.parser;

import java.io.IOException;
import ch.unibe.piccola.source.SourceCode;
import ch.unibe.piccola.syntax.Node;

/**
 * Abstract base class for Piccola parsers.
 *
 * @author   Stefan Kneubuehl
 * @version  3.4c (Dec 09, 2002)
**/
public abstract class Parser
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    /**
     * Parser the specified source code and returns the root node of the
     * syntax tree.
     *
     * @param  sourceCode the source code to be parsed.
     * @return the root node of the syntax tree.
     * @throws ParserException if a parse error occurs.
     * @throws IOException     if an error occurs while reading from the
     *                         source code.
    **/
    public abstract Node parse(SourceCode sourceCode)
        throws IOException, ParserException;

}