package ch.unibe.piccola.syntax;

import ch.unibe.piccola.source.SourceRef;

/**
 * Represents an empty form syntax node.
 *
 * @author   Stefan Kneubuehl
 * @version  3.4c (Nov 14, 2002)
**/
public class Empty extends LeafNode
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    /**
     * Accepts a node visitor.
     *
     * @param  visitor the node visitor to be accepted.
     *
     * @return the result of the visitor's visitEmpty method.
    **/
    public Object accept(NodeVisitor visitor)
    {
        return visitor.visitEmpty(this);
    }

    /**
     * Returns a debug string representation of this empty node.
     *
     * @return a debug string representation of this empty node.
    **/
    public String toString()
    {
        return "Empty";
    }

    // ------------------------------------------------------------------------
    // default
    // ------------------------------------------------------------------------

    Empty(SourceRef sourceRef)
    {
        super(sourceRef);
    }

}