package ch.unibe.piccola.syntax;

import ch.unibe.piccola.source.SourceRef;

/**
 * @author   Stefan Kneubuehl
 * @version  3.4c (Nov 14, 2002)
**/
public class FixedPoint extends LabelledOneChildNode
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    /**
     * Accepts a node visitor.
     *
     * @param  visitor the node visitor to be accepted.
     *
     * @return the result of the visitor's visitFixedPoint method.
    **/
    public Object accept(NodeVisitor visitor)
    {
        return visitor.visitFixedPoint(this);
    }

    /**
     * Returns a debug string representation of this fixed point node.
     *
     * @return a debug string representation of this fixed point node.
    **/
    public String toString()
    {
        return "FixedPoint" + super.toString();
    }

    // ------------------------------------------------------------------------
    // default
    // ------------------------------------------------------------------------

    FixedPoint(SourceRef sourceRef, Node child, String label)
    {
        super(sourceRef, child, label);
    }

    // ------------------------------------------------------------------------
    // protected
    // ------------------------------------------------------------------------

    protected Node newInstance(Node child)
    {
        return new FixedPoint(getSourceRef(), child, getLabel());
    }

}