package ch.unibe.piccola.syntax;

import ch.unibe.piccola.source.SourceRef;

/**
 * Represents a hide syntax node.
 *
 * @author   Stefan Kneubuehl
 * @version  3.4c (Nov 14, 2002)
**/
public class Hide extends LabelledOneChildNode
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    /**
     * Accepts a node visitor.
     *
     * @param  visitor the node visitor to be accepted.
     *
     * @return the result of the visitor's visitHide method.
    **/
    public Object accept(NodeVisitor visitor)
    {
        return visitor.visitHide(this);
    }

    /**
     * Returns a debug string representation of this hide node.
     *
     * @return a debug string representation of this hide node.
    **/
    public String toString()
    {
        return "Hide" + super.toString();
    }

    // ------------------------------------------------------------------------
    // default
    // ------------------------------------------------------------------------

    Hide(SourceRef sourceRef, Node child, String label)
    {
        super(sourceRef, child, label);
    }

    // ------------------------------------------------------------------------
    // protected
    // ------------------------------------------------------------------------

    protected Node newInstance(Node child)
    {
        return new Hide(getSourceRef(), child, getLabel());
    }

}