package ch.unibe.piccola.type;

import java.util.ArrayList;

/**
 * Represents the type '()'.
 *
 * @author    Stefan Kneubuehl
 * @version   3.4c (Jan 04, 2003)
**/
public class TypeEmpty extends Type
{

    // ------------------------------------------------------------------------
    // public static
    // ------------------------------------------------------------------------

    public static final TypeEmpty INSTANCE = new TypeEmpty();

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    /**
     * Implements type equivalence '()^R = R'.
    **/
    public Type and(Type type)
    {
        return type;
    }

    /**
     * Implements type equivalence '().P = P'.
    **/
    public Type extend(Type type)
    {
        return type;
    }

    /**
     * Implements type equivalence '()\x = ()'.
    **/
    public Type hide(String x)
    {
        return this;
    }

    public void simplifyConstraint(ArrayList list, Type provided)
    {
        if (provided.isVariable()) {
            super.simplifyConstraint(list, provided);
        }
    }

    public String toString()
    {
        return "()";
    }

    // ------------------------------------------------------------------------
    // protected
    // ------------------------------------------------------------------------

    /**
     * Implements type equivalence 'R^() = R'.
    **/
    protected Type andLeft(Type left)
    {
        return left;
    }

    /**
     * Implements type equivalence 'P.() = P'.
    **/
    protected Type extendLeft(Type left)
    {
        return left;
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private TypeEmpty()
    {
    }

}