package ch.unibe.piccola.vm;

import java.util.SortedMap;
import ch.unibe.piccola.type.ContractualType;

/**
 * @author   Stefan Kneubuehl
 * @version  3.6c (Apr 23, 2003)
**/
class BindingForm extends DefaultForm {

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    public boolean exists(String label)
    {
        return m_label.equals(label);
    }

    public Form hide(String label)
    {
        return m_label.equals(label) ? factory().emptyForm() : this;
    }

    public boolean runtimeEquals(Form form)
    {
        Object object = down();
        if (this != object) {
            return object.equals(form.down());
        }
        if (form instanceof BindingForm) {
            BindingForm other = (BindingForm) form;
            return m_label.equals(other.m_label) &&
                   m_form.equals(other.m_form);
        }
        return false;
    }

    public int runtimeHashCode()
    {
        return m_label.hashCode();
    }

    public String runtimeToString()
    {
        return "(" + m_label + " = " + m_form.toString() + ")";
    }

    public ContractualType type()
    {
        return m_form.type().label(m_label);
    }

    // ------------------------------------------------------------------------
    // default
    // ------------------------------------------------------------------------

    BindingForm(FormFactory factory, String label, Form form)
    {
        super(factory);
        m_label = label;
        m_form = form;
    }

    // ------------------------------------------------------------------------
    // protected
    // ------------------------------------------------------------------------

    protected SortedMap buildBindings()
    {
        SortedMap bindings = super.buildBindings();
        bindings.put(m_label, m_form);
        return bindings;
    }

    public Form projectDef(String label, Form defaultForm)
    {
        return m_label.equals(label) ? m_form : defaultForm;
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private final String m_label;

    private final Form m_form;

}
