package ch.unibe.piccola.vm;

import junit.framework.TestCase;
import junit.framework.TestSuite;

/**
 * @author   Stefan Kneubuehl
 * @version  3.4c (Oct 04, 2002)
**/
public class ExtensionFormTest extends TestCase
{

    // ------------------------------------------------------------------------
    // test suite
    // ------------------------------------------------------------------------

    public ExtensionFormTest(String name)
    {
        super(name);
    }

    public static TestSuite suite()
    {
        return new TestSuite(ExtensionFormTest.class);
    }

    public static void main(String[] args)
    {
        junit.textui.TestRunner.run(suite());
    }

    // ------------------------------------------------------------------------
    // test environment
    // ------------------------------------------------------------------------

    public void setUp()
    {
        ff = new FormFactory();
        pool = new VMPool();
        empty = ff.emptyForm();
        hello = pool.wrap("Hello");
        hello = hello.extend(empty.bind("test"));
        ext = empty.bind("a").extend(empty.bind("b"));
    }

    private VMPool pool;

    private FormFactory ff;

    private Form ext;

    private Form hello;

    private Form world;

    private Form empty;

    private Form sys;

    private Form url;

    // ------------------------------------------------------------------------
    // tests
    // ------------------------------------------------------------------------

    public void testExists()
    {
        assertTrue(hello.exists("wait"));
        assertTrue(hello.exists("test"));
    }

    public void testDown()
    {
        assertEquals("Hello", hello.down());
        assertEquals(ext, ext.down());
    }

    public void testRuntimeEquals()
    {
        Form hello2 = pool.wrap("Hello");
        assertTrue(hello2.runtimeEquals(hello));
        hello2 = hello2.extend(empty.bind("xyz"));
        assertTrue(hello2.runtimeEquals(hello));
        assertTrue(hello.runtimeEquals(hello2));
        assertTrue(ext.equals(empty.bind("b").extend(empty.bind("a"))));
    }

    public void testProject()
    {
        assertEquals(empty, hello.project("test"));
    }

    public void testUnwrap()
    {
        assertEquals(hello.unwrap(), hello);
        assertEquals(hello.project("peer").unwrap(), "Hello");
    }

}

