package ch.unibe.piccola.vm;

import ch.unibe.piccola.syntax.Syntax;

/**
 * @author   Stefan Kneubuehl
 * @version  3.4c (Oct 10, 2002)
 *
 * Represents <i>(peer = PeerForm, PeerForm)</i>
**/
public class ExternalForm extends ExtensionForm {

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private static final String LABEL_PEER = Syntax.labelPeer();

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    public boolean runtimeEquals(Form form)
    {
        return m_object.equals(form.down());
    }

    public String runtimeToString()
    {
        return m_peer.runtimeToString();
    }

    public String toString()
    {
        return "ExternalForm[" + m_peer.toString() + "]";
    }

    public Object unwrap()
    {
        return this;
    }

    // ------------------------------------------------------------------------
    // default
    // ------------------------------------------------------------------------

    ExternalForm(FormFactory factory, PeerForm peer)
    {
        super(factory, peer.bind(LABEL_PEER), peer);
        m_object = peer.unwrap();
        m_class = m_object.getClass();
        m_peer = peer;
    }

    // ------------------------------------------------------------------------
    // protected
    // ------------------------------------------------------------------------

    public void push(VM vm)
    {
        vm.doPushPeerForm(this, m_class);
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private Class m_class;

    private Object m_object;

    private PeerForm m_peer;

}

