package ch.unibe.piccola.vm;

import ch.unibe.piccola.code.OpCode;

/**
 * @author   Stefan Kneubuehl
 * @version  3.4c (Aug 15, 2002)
**/
public interface IAgentObserver
{

    /**
     * This method is called after the observed VM executes an opcode.
    **/
    public void afterExecute(OpCode opcode);

    /**
     * This method is called before the observed VM executes an opcode. The
     * opcode will be executed just after the thread returns from this method.
    **/
    public void beforeExecute(OpCode opcode);

    public void onSend(Agent agent);

    public void onReceive(Agent agent);

    public void onBlock(Agent agent);

    public void onStart(Agent agent);

    public void onStop(Agent agent);

    public void onUnblock(Agent agent);

}