package ch.unibe.piccola.vm;

import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.util.SortedMap;
import java.util.TreeMap;

/**
 * @author   Stefan Kneubuehl
 * @version  3.4c (Jun 01, 2003)
**/
public class PeerClassForm extends PeerForm
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    public String runtimeToString()
    {
        return "class(" + m_class.getClassName() + ')';
    }

    // ------------------------------------------------------------------------
    // default
    // ------------------------------------------------------------------------

    PeerClassForm(FormFactory factory, VMPool pool, Class cl)
    {
        super(factory, pool, cl);
        m_class = JavaClass.lookup(cl);
    }

    // ------------------------------------------------------------------------
    // protected
    // ------------------------------------------------------------------------

    protected SortedMap ats()
    {
        return m_class.getClassAttributes();
    }

    protected SortedMap ops()
    {
        return m_class.getClassOperations();
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private JavaClass m_class;

}
